
// Persistence of Vision Ray Tracer Scene Description File
// POV-Ray 3.0
// File: KR200.pov
// Vers: 1.0
// Desc: Kugelraumer 200m Durchmesser
//       Schwerer Kreuzer der TERRA-Klasse
// Date: 20.01.97
// Auth: Harald Ottacher
//       email: ottacher@iwf.tu-graz.ac.at
//
////////////////////////////////////////////////////


// ==== Standard POV-Ray Includes ====
#include "colors.inc"	// Standard Color definitions
#include "textures.inc"	// Standard Texture definitions

// ==== Additional Includes ====
#include "consts.inc"

////////////////////////////////////////////////////

//camera {
//  orthographic
//  location  < -300.0, 0.0, -300.0>
//  direction 1.3*z
//  up        y
//  right     4/3*x
//  look_at   < 0.0, 0.0, 0.0>
//}
camera {
  orthographic
  location  < 0.0, 0.0, -300.0>
  direction 1.3*z
  up        <0, 200, 0>
  right     <200*4/3, 0, 0>
  look_at   < 0.0, 0.0, 0.0>
}

////////////////////////////////////////////////////

light_source {
  0*x
  color red 1.0  green 1.0  blue 1.0
  translate <-200, 200, -400>
}

light_source {
  0*x
  color Gray70
  translate < 0, 0, -400>
  shadowless
}

////////////////////////////////////////////////////

#declare _STARS  = 0;

#ifdef (_STARS)
#declare Starfield=
texture {
  pigment {
    granite
      color_map {
        [ 0.0000  0.2700 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
        [ 0.2700  0.2710 color rgb <.6,.6,.4> color rgb <.9,.9,.4> ]
        [ 0.2710  0.4700 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
        [ 0.4700  0.4720 color rgb <.4,.4,.5> color rgb <.4,.4,.7> ]
        [ 0.4720  0.6800 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
        [ 0.6800  0.6820 color rgb <.5,.4,.4> color rgb <.7,.4,.4> ]
        [ 0.6820  0.8800 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
        [ 0.8800  0.8815 color rgb <.5,.5,.5> color rgb < 1, 1, 1> ]
        [ 0.8815  1.0000 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
      }
    turbulence 1
    sine_wave
    scale .5
  }
  finish { diffuse 0 ambient 1 }
}
#else
#declare Starfield =
texture {
  pigment { Black }
}
#end // if _STARS

object {
   sphere { < 0, 0, 0 >, 1 }
   hollow
   texture { Starfield }
   scale 100000
} // end object

////////////////////////////////////////////////////

#include "KR200.INC"

object {
  KR200
  rotate < 0, -90, 0 >
  // rotate < -10, 0, 0 >
}
