#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "metals.inc"
#include "stones.inc"

#declare SCHNITT_1 = 1;	// Quadrant -/*/-

global_settings {
        assumed_gamma 1.0
        ambient_light rgb<0.5, 0.5, 0.5>
}
background { color rgb<0.2, 0.4, 0.8>  }
light_source {
    <-200, 200, -200>
    color White
}

#local CP = <100, 0, 0>;
light_source {
    CP
    color White*0.5
}
camera {
	orthographic
        location CP
        look_at <-0, 0, 0>
	angle 20
}

#include "huelle.pov"
#include "deck_01.pov"

union {
    object {
	deck_01
    }
    cylinder {
	<100, -43, -100>, 
	<100, -43, +100>, 
	0.2
	pigment { color <1, 1, 1> }
    }
    cylinder {
	<100, -44, -100>, 
	<100, -44, +100>, 
	0.2
	pigment { color <1, 1, 0> }
    }
    cylinder {
	<100, -45, -100>, 
	<100, -45, +100>, 
	0.2
	pigment { color <1, 0, 0> }
    }
    cylinder {
	<100, -40, 0>, 
	<100, -55, 0>, 
	0.2
	pigment { color <1, 0, 0> }
    }
    translate <0, 52, 0>
}


cylinder {
    <0, 0, 0>,
    <0, -1, 0>, 1000
    pigment {
	radial
	color_map{
	    [0.1 rgb 0.1 ]
	    [0.1 White]
	}
	frequency 16
    }
}


/*
cone {
    <0, 0, 0>, 0
    <1000, 0, 0>, 10
    pigment { color <1, 0, 0> }
}

cone {
    <0, 0, 0>, 0
    <0, 1000, 0>, 10
    pigment { color <0, 1, 0> }
}

cone {
    <0, 0, 0>, 0
    <0, 0, 1000>, 10
    pigment { color <0, 0, 1> }
}
*/
