#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "metals.inc"
#include "stones.inc"

#declare SCHNITT_1 = 1;	// Quadrant -/*/-

global_settings {
        assumed_gamma 1.0
        ambient_light rgb<0.5, 0.5, 0.5>
}
background { color rgb<0.2, 0.4, 0.8>  }
light_source {
    <-200, 200, -200>
    color White
}

#local CP = <-0, 3, +40>;
light_source {
    CP
    color White*0.5
}
camera {
        location CP
        look_at <-0, 3.0, +12>
	angle 40
}

#declare cut1 = 
	    prism {
		linear_sweep
		linear_spline
		12	// min y
		30  // max y
		8	// nr points
		<-1, 0> <-5.1, 1> <-1, 2> <0, 4.6>
		<1, 2> <5.1, 1> <1, 0>
		<-1, 0>
		rotate <-90, 0, 0>	// +x -> +x, +z -> +y, +y -> -z
		scale <1, 1, -1>
		pigment { 
		    color rgbf <0, 1, 1, 0>
		}
	    }

#declare cut2 =
    box {
	<-5, 0, 12> <5, 4.6, 30>
	pigment { 
	    color rgbf <0, 1, 0, 0>
	}
    }
	difference {
	    cylinder {
		<0, 0, 12> <0, 4.8, 12>, 8.05
		pigment { 
		    color rgbf <1, 1, 1, 0.3>
		}
	    }
	    cylinder {
		<0, 0, 12> <0, 4.81, 12>, 8.00
		pigment { 
		    color rgbf <1, 1, 1, 0.3>
		}
	    }
	    object {
		cut1
	    }

	}

cone {
    <0, 0, 0>, 0
    <1000, 0, 0>, 10
    pigment { color <1, 0, 0> }
}

cone {
    <0, 0, 0>, 0
    <0, 1000, 0>, 10
    pigment { color <0, 1, 0> }
}

cone {
    <0, 0, 0>, 0
    <0, 0, 1000>, 10
    pigment { color <0, 0, 1> }
}
